package pejb.rmi.server;
import java.rmi.*;
import java.rmi.server.*;
import java.rmi.registry.Registry;
import pejb.rmi.base.*;

public class GenericServer extends UnicastRemoteObject implements Workable {
	public GenericServer() throws RemoteException {
		super();
	}
	
	public java.io.Serializable doJob(AnyThing any ) {
		return any.doThing();
	}
	
	public static void main(String[] args) {
		String rmiString = null;
		int port = Registry.REGISTRY_PORT;
		if(args.length < 1) {
			System.out.println("Usage: java GenericServer port");
			System.exit(1);
		} else {
		
			try {
				port = Integer.parseInt(args[0]);
			} catch(NumberFormatException e) {
				System.err.println("Port Number is not a valid Number String. Setting port number default...");
			}
		}		
		rmiString = RmiUtil.getRmiString(Workable.NAME, port);
		System.setSecurityManager(new RMISecurityManager());
		try {
			Workable qry = new GenericServer();
			System.out.println(rmiString);
			Naming.rebind(rmiString, qry);
			System.out.println("Remote Object registered and ready to serve incoming remote method call ...");
		} catch (Exception e) {
			System.err.println("Couldn't successfully register remote object");
			e.printStackTrace();
		}
	}
}

