package pejb.ejb.session.board;
import javax.ejb.*;
import java.rmi.*;
import java.sql.*;
import pejb.ejb.base.*;
import pejb.ejb.entity.board.*;
import pejb.beans.board.BoardRec;

public class InsertRecBean extends SessionAdapter{
	
	private Connection conn;
	private ResultSet rset;
	private Statement stmt;
	private EJBUtil util;
	private BoardHome board_home;
	String jndi_enc ="";

	////////// ejbCreate() ...////////
	public void ejbCreate() {
		print("ejbCreate called");
	}
	
	//////// Business Mehtods ///////////
	// Է
	public int insertRec(BoardRec rec) throws RemoteException{
		int maxRecno = 0;
		Date date = new Date(System.currentTimeMillis());
		try {
			maxRecno = getMaxRecno();
			board_home.create(maxRecno, maxRecno, rec.getUserId(), 
			rec.getUserName(),rec.getEmail(),rec.getSubject(), 
			rec.getContents(), rec.getPasswd(), date);
		} catch(CreateException e) {
			e.printStackTrace();
			if(e instanceof DuplicateKeyException ) insertRec(rec);
		} catch(SQLException e) {
			throw new RemoteException(e.getMessage());
		}
		return maxRecno;
	}
	//亯 Է	
	public int insertReplyRec(BoardRec rec) throws RemoteException {
		int ref = rec.getRef();
		int depth = rec.getDepth();
		int step = rec.getStep();
		int maxRecno = 0;
		Date date = new Date(System.currentTimeMillis());
		String userId = rec.getUserId();
		String userName = rec.getUserName();
		String email = rec.getEmail();
		String subject = rec.getSubject();
		String contents = rec.getContents();
		String passwd = rec.getPasswd();
		try {
			int replyStep = getReplyStep(ref, depth, step);
			System.out.println("ref " + ref + " depth " + depth + " maxrecno " + maxRecno + " step " + step + " replystep " + replyStep);
			maxRecno = getMaxRecno();
			board_home.create(maxRecno, ref,replyStep, depth + 1, 
			userId, userName ,email, subject, contents, passwd, date);
			//߰ ۷    step 
			updateReplyStep(ref, depth, step, maxRecno);			
			// 亯(replycnt) .. 
			updateReplyCnt(depth, ref, replyStep );
		} catch(SQLException e) {
			throw new RemoteException(e.getMessage());
		} catch(CreateException e) {
			if(e instanceof DuplicateKeyException)
				insertReplyRec(rec);
		}
		return maxRecno;
	}

	///////////// Overriden from SessionAdapter ///////////
	public void setSessionContext(SessionContext ctx ) throws RemoteException, EJBException {
		util = new EJBUtil();
		board_home = (BoardHome)util.lookup("java:comp/env/ejb/Board", BoardHome.class);
		this.jndi_enc = (String)util.getEnvEntry("ConnectionPool");
		this.ejb_name = getClass().getName();
		this.debug = true;
		super.setSessionContext(ctx);
	}
	public void ejbRemove() {
		print("ejbRemove called");
	}

	//////////// private Utilities ////////////
	//亯ۿ insert Ǵ step 
	private int getReplyStep(int ref, int depth, int step) throws SQLException{
		conn = util.getConnection(jndi_enc);
		stmt = conn.createStatement();
		int compareStep = 0, replyStep = 0;
		String query = "select min(step) from board where ref = " + ref 
		+ " and depth <= " + depth + " and step > "+ step;
		try{
			rset = stmt.executeQuery(query);
			if(rset.next()) { compareStep = rset.getInt(1); }
			if(compareStep != 0) {
				replyStep = compareStep;
			} else {
				rset = stmt.executeQuery("select max(step) + 1 from board where ref = " + ref);
				if(rset.next()) { replyStep = rset.getInt(1); }
			}
			return replyStep;
		} catch(SQLException e) {
			throw e;
		} finally {
			close(rset, stmt, conn);
		}	
	}
	//亯 Է  ۵ step update
	private int updateReplyStep (int ref, int depth, int step, int recno) throws SQLException {
		conn = util.getConnection(jndi_enc);
		stmt = conn.createStatement();
		int affectedRowCount = -1;
		try {
			String query =  ("select count(*), min(step) from board where ref = " 
			+ ref + " and depth <= " + depth + " and step > "+ step);
			rset = stmt.executeQuery(query);

			if(rset.next()) {
				if(rset.getInt(1) > 0) {
					query = ("update board set step = step + 1 where ref = " + 
					ref + "and recno != " + recno + " and step >= " + rset.getInt(2));
					affectedRowCount = stmt.executeUpdate(query);
				}
			}
			return affectedRowCount; 
		} finally {
			close(rset, stmt, conn);
		}
	}
	//亯 Է  亯(replyCnt) 
	private void updateReplyCnt(int depth, int ref, int replyStep) throws SQLException {
		StringBuffer sb = new StringBuffer();
		PreparedStatement pstmt = null;
		conn = util.getConnection(jndi_enc);
		sb.append("update board set replycnt = replycnt+1 ");
		sb.append(" where ref = ? and depth = ? and step = ");
		sb.append("(select max(step) from board where ref = ? and depth = ? and step < ? )");
		try {
			pstmt = conn.prepareStatement(sb.toString());
			for(int i=depth; i>=0; i--) {
				pstmt.clearParameters();
				pstmt.setInt(1,ref);
				pstmt.setInt(2, i);
				pstmt.setInt(3, ref);
				pstmt.setInt(4, i);
				pstmt.setInt(5, replyStep);
				pstmt.executeUpdate();
			}
		} finally {
			close(null, pstmt,conn);
		}
	}	
	// insert ÿ Primary Key  Ǵ recno.. 
	private int getMaxRecno() throws SQLException{
		conn = util.getConnection(jndi_enc);
		stmt = conn.createStatement();
		int maxRecno = 0;
		String query = "select nvl(max(recno),0)+1 from board";
		try{
			rset = stmt.executeQuery(query);
			if(rset.next()) maxRecno = rset.getInt(1);
			return maxRecno;
		} catch(SQLException e) {
			throw e;
		} finally {
			close(rset, stmt, conn);
		}
	}	
	private void close(ResultSet rset, Statement stmt, Connection conn) {
		try {
			if(rset != null) { rset.close(); rset = null;}
			if(stmt != null) { stmt.close(); stmt = null; }
			if(conn != null) {
				conn.close();
				conn = null;
			}
		} catch(Exception e) { e.printStackTrace(); }
	}
}