package pejb.shopmall.beans;
import javax.ejb.*;
import java.rmi.*;
import java.util.*;
import pejb.shopmall.ejb.*;
import pejb.shopmall.*;
import pejb.ejb.base.*;

public class CartBean {
	private SCart cart;
	private EJBUtil util;
	public CartBean() throws RemoteException, CreateException{
		util = new EJBUtil();
		SCartHome home = 
		(SCartHome) util.lookup("SCart", SCartHome.class);
		cart = home.create();
	}
	public void addItem(BookBean book) 
	throws RemoteException, InvalidUserInputException {
		cart.addItem(book);
	}
	public void removeItem(BookBean book) 
	throws RemoteException, ItemNotFoundException {
		cart.removeItem(book);
	}
	public Hashtable getItems() throws RemoteException{
		return cart.getItems();
	}
	public  String getPrevParam() throws RemoteException {
		return cart.getPrevParam();
	}
	public Enumeration getBooks() throws RemoteException{
		return cart.getBooks();
	}
	public void setPrevParam(String prevParam) throws RemoteException{
		cart.setPrevParam(prevParam);
	}
	public void setEmpty(boolean empty) throws RemoteException {
		if(empty) {
			cart.clearItems();
		}
	}
	public CartBean getCart() {
		return this;
	}	
	public String toString() {
		String str = "Something's Wrong with SCart EJB ";
		try {
			str = cart.getCartFormatStr();
		} catch(RemoteException e) {
			e.printStackTrace();
		}
		return str;
	}
	public SCart getCartEJB() {
		return cart;
	}
}