package pejb.shopmall.ejb;
import javax.ejb.*;
import java.net.URLEncoder;
import java.rmi.RemoteException;
import pejb.ejb.base.SessionAdapter;
import pejb.shopmall.beans.BookBean;
import java.util.*;
import pejb.shopmall.*;
public class SCartBean extends SessionAdapter {
	private BookBean lastItem;
	private Hashtable items = new Hashtable();
	private String prevParam = "";
	
	public void ejbCreate() {
	}
	public void addItem(BookBean book) throws InvalidUserInputException {
		if(book.getQuantity() > 0) {
			if(items.containsKey(book.getIsbn())) {
				BookBean item = (BookBean)items.get(book.getIsbn());
				long quantity = item.getQuantity() + book.getQuantity();
				item.setQuantity(quantity);
			} else {
				lastItem = book;
				items.put(book.getIsbn(), book);
			}
		} else {
			throw new InvalidUserInputException("Please input a valid quantity[0 or negative value is invalid]");
		}
	}
	public void removeItem(BookBean book) throws ItemNotFoundException {
		Object key = items.remove(book.getIsbn());
		if(key == null) 
		throw new ItemNotFoundException("Such Item[BookBean] with ISBN: " 
		+ key + " was not found in the cart ");
	}
	public String getCartFormatStr() {
		return formatString();
	}	
	public Hashtable getItems() {
		return items;
	}
	public  String getPrevParam() {
		if(items.isEmpty()) {
			return prevParam;
		} else {
			String title = lastItem.getTitle();
			String category = lastItem.getCategory();
			if(title != null && category != null) {
				prevParam = "title=" + URLEncoder.encode(title) 
				+ "&category=" + URLEncoder.encode(category);
				return prevParam;
			} else {
				return "title=+&category=+";
			}
		}
	}
	public Enumeration getBooks() {
		Enumeration books = items.elements();
		return books;
	}
	public void setPrevParam(String prevParam) {
		this.prevParam = prevParam;
	}
	public void clearItems() {
		if(!items.isEmpty()) {
			items.clear();
		}
	}
	
	public void setSessionContext(SessionContext ctx) throws RemoteException, EJBException {
		ejb_name = getClass().getName();
		debug = true;
		super.setSessionContext(ctx);
	}	
	private String formatString() {
		long num_books = 0;
		long num = 0;
		long total_price = 0;
		Enumeration enum = items.elements();
		StringBuffer sb = new StringBuffer(2 * 1024);
		if(items.isEmpty()) return "Ͻ ǰ ϴ.!"; 
		while(enum.hasMoreElements()) {
			BookBean book = (BookBean) enum.nextElement();
			num = book.getQuantity();
			total_price += book.getPrice() * num;
			num_books += num;
			sb.append(book.toString());
		}
		sb.append(": " + num_books + "&nbsp;&nbsp; հ: " + total_price +"  <P> ");
		return sb.toString();
	}
}
