package pejb.shopmall.ejb;
import javax.ejb.*;
import java.rmi.*;
import java.sql.*;
import java.util.*;
import pejb.ejb.base.*;
import pejb.shopmall.beans.*;
public class SShopBean extends SessionAdapter{
	private String orderListQuery = null;
	private LoginInfoBean userInfo;
	private SCart cart;
	private EBookHome book_home;
	private EJBUtil util;
	private String jndi_dataSource = "java:comp/env/jdbc/ShopDB";	
	private Connection conn = null;
	public void ejbCreate(LoginInfoBean userInfo, SCart cart) 
	throws CreateException{
		if(userInfo == null || cart == null) {
			throw new CreateException("User Information: NULL or Shopping Cart EJB ref: NULL");
		}
		this.userInfo = userInfo;
		this.cart = cart;
	}		

	public void completeOrder() throws RemoteException {
		try {
			Enumeration books = cart.getBooks();
			while(books.hasMoreElements()) {
				BookBean book = (BookBean)books.nextElement();
				updateDB(book);
				updateOrderListDB(book);
			}
		} catch(FinderException e) {
			throw new RemoteException(e.getMessage());
		} catch(SQLException e) {
			throw new RemoteException(e.getMessage());
		}
	}
	public void setSessionContext(SessionContext ctx) 
	throws RemoteException, EJBException {
		debug = true;
		ejb_name = getClass().getName();
		util = new EJBUtil();
		jndi_dataSource = (String)util.getEnvEntry("ConnectionPool");
		book_home = (EBookHome)util.lookup("java:comp/env/ejb/EBook", EBookHome.class);
		super.setSessionContext(ctx);
	}
	
	private void updateDB(BookBean book) throws RemoteException, FinderException {
		EBook ejb = 
		book_home.findByPrimaryKey(new EBookPK(book.getIsbn()));
		long remaining = ejb.getRemaining() - book.getQuantity();
		ejb.setRemaining(remaining);
	}
	private void updateOrderListDB(BookBean book) throws SQLException {
		String id = userInfo.getId();
		String passwd = userInfo.getPasswd();
		String name = userInfo.getName();
		String address = userInfo.getAddress();
		String phone = userInfo.getPhone();
	
		String isbn = book.getIsbn();
		String title = book.getTitle();
		long quantity = book.getQuantity();
		long price = book.getPrice();
		PreparedStatement pstmt = null;
		try {
			conn = getConnection();
			StringBuffer sb = new StringBuffer();
			sb.append("insert into orderlist ");
			sb.append("(id, passwd, name, address, phone, isbn, title, quantity, price)");
			sb.append(" values(?, ?, ?, ?, ?, ?, ?, ?, ?)");
			
			pstmt = conn.prepareStatement(sb.toString());
			pstmt.setString(1, id);
			pstmt.setString(2, passwd);
			pstmt.setString(3, name);
			pstmt.setString(4, address);
			pstmt.setString(5, phone);
			pstmt.setString(6, isbn);
			pstmt.setString(7, title);
			pstmt.setLong(8, quantity);
			pstmt.setLong(9, price);
			pstmt.executeUpdate();
		} finally {
			close(null, pstmt, conn);			
		}
	}
		
	private Connection getConnection() {
		return util.getConnection(jndi_dataSource);
	}
	private void close(ResultSet rset, Statement stmt, Connection conn) {
		try {
			if(rset != null) rset.close();
			if(stmt != null) stmt.close();
			if(conn != null) {
				conn.close();
				conn = null;
			}
		} catch(Exception e) { e.printStackTrace(); }
	}	
}
